Update ubuntu-v4.sh

This commit is contained in:
tteckster 2022-07-31 20:13:34 -04:00 committed by GitHub
parent d0090a8cd0
commit 78fa9a70f7
No known key found for this signature in database
GPG key ID: 4AEE18F83AFDEB23

View file

@ -27,7 +27,6 @@ set -o pipefail
shopt -s expand_aliases shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit' alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR trap die ERR
function error_exit() { function error_exit() {
trap - ERR trap - ERR
local reason="Unknown failure occurred." local reason="Unknown failure occurred."
@ -36,7 +35,6 @@ function error_exit() {
echo -e "$flag $msg" 1>&2 echo -e "$flag $msg" 1>&2
exit $EXIT exit $EXIT
} }
if (whiptail --title "${APP} LXC" --yesno "This will create a New ${APP} LXC. Proceed?" 10 58); then if (whiptail --title "${APP} LXC" --yesno "This will create a New ${APP} LXC. Proceed?" 10 58); then
echo "User selected Yes" echo "User selected Yes"
else else
@ -53,28 +51,23 @@ echo -e "${YW}
\____/_.___/\__,_/_/ /_/\__/\__,_/ \____/_.___/\__,_/_/ /_/\__/\__,_/
${CL}" ${CL}"
} }
function msg_info() { function msg_info() {
local msg="$1" local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..." echo -ne " ${HOLD} ${YW}${msg}..."
} }
function msg_ok() { function msg_ok() {
local msg="$1" local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}" echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
} }
function PVE_CHECK() { function PVE_CHECK() {
PVE=$(pveversion | grep "pve-manager/7" | wc -l) PVE=$(pveversion | grep "pve-manager/7" | wc -l)
if [[ $PVE != 1 ]]; then
if [[ $PVE != 1 ]]; then echo -e "${RD}This script requires Proxmox Virtual Environment 7.0 or greater${CL}"
echo -e "${RD}This script requires Proxmox Virtual Environment 7.0 or greater${CL}" echo -e "Exiting..."
echo -e "Exiting..." sleep 2
sleep 2 exit
exit fi
fi
} }
function default_settings() { function default_settings() {
echo -e "${DGN}Using ${var_os} Version: ${BGN}${var_version}${CL}" echo -e "${DGN}Using ${var_os} Version: ${BGN}${var_version}${CL}"
#var_version="22.04" #var_version="22.04"
@ -104,23 +97,19 @@ function default_settings() {
VLAN="" VLAN=""
echo -e "${BL}Creating a ${APP} LXC using the above default settings${CL}" echo -e "${BL}Creating a ${APP} LXC using the above default settings${CL}"
} }
function advanced_settings() { function advanced_settings() {
var_version=$(whiptail --title "UBUNTU VERSION" --radiolist "Choose Version" 10 58 4 \ var_version=$(whiptail --title "UBUNTU VERSION" --radiolist "Choose Version" 10 58 4 \
"18.04" "18.04" OFF \ "18.04" "Bionic" OFF \
"20.04" "20.04" OFF \ "20.04" "Focal" OFF \
"21.10" "21.10" OFF \ "21.10" "Impish" OFF \
"22.04" "22.04" ON \ "22.04" "Jammy" ON \
3>&1 1>&2 2>&3) 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Using Ubuntu Version: ${BGN}$var_version${CL}" echo -e "${DGN}Using Ubuntu Version: ${BGN}$var_version${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
CT_TYPE=$(whiptail --title "CONTAINER TYPE" --radiolist "Choose Type" 8 58 2 \ CT_TYPE=$(whiptail --title "CONTAINER TYPE" --radiolist "Choose Type" 8 58 2 \
"1" "Unprivileged" ON \ "1" "Unprivileged" ON \
"0" "Privileged" OFF \ "0" "Privileged" OFF \
@ -129,11 +118,8 @@ exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Using Container Type: ${BGN}$CT_TYPE${CL}" echo -e "${DGN}Using Container Type: ${BGN}$CT_TYPE${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
PW1=$(whiptail --inputbox "Set Root Password" 8 58 --title "PASSWORD(leave blank for automatic login)" 3>&1 1>&2 2>&3) PW1=$(whiptail --inputbox "Set Root Password" 8 58 --title "PASSWORD(leave blank for automatic login)" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
@ -144,78 +130,56 @@ else
echo -e "${DGN}Using Root Password: ${BGN}$PW1${CL}" echo -e "${DGN}Using Root Password: ${BGN}$PW1${CL}"
fi fi
fi fi
CT_ID=$(whiptail --inputbox "Set Container ID?" 8 58 $NEXTID --title "CONTAINER ID" 3>&1 1>&2 2>&3) CT_ID=$(whiptail --inputbox "Set Container ID?" 8 58 $NEXTID --title "CONTAINER ID" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Using Container ID: ${BGN}$CT_ID${CL}" echo -e "${DGN}Using Container ID: ${BGN}$CT_ID${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
CT_NAME=$(whiptail --inputbox "Set Hostname" 8 58 $NSAPP --title "HOSTNAME" 3>&1 1>&2 2>&3) CT_NAME=$(whiptail --inputbox "Set Hostname" 8 58 $NSAPP --title "HOSTNAME" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
HN=$(echo ${CT_NAME,,} | tr -d ' ') HN=$(echo ${CT_NAME,,} | tr -d ' ')
echo -e "${DGN}Using Hostname: ${BGN}$HN${CL}" echo -e "${DGN}Using Hostname: ${BGN}$HN${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
DISK_SIZE=$(whiptail --inputbox "Set Disk Size in GB" 8 58 $var_disk --title "DISK SIZE" 3>&1 1>&2 2>&3) DISK_SIZE=$(whiptail --inputbox "Set Disk Size in GB" 8 58 $var_disk --title "DISK SIZE" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Using Disk Size: ${BGN}$DISK_SIZE${CL}" echo -e "${DGN}Using Disk Size: ${BGN}$DISK_SIZE${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
CORE_COUNT=$(whiptail --inputbox "Allocate CPU Cores" 8 58 $var_cpu --title "CORE COUNT" 3>&1 1>&2 2>&3) CORE_COUNT=$(whiptail --inputbox "Allocate CPU Cores" 8 58 $var_cpu --title "CORE COUNT" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Allocated Cores: ${BGN}$CORE_COUNT${CL}" echo -e "${DGN}Allocated Cores: ${BGN}$CORE_COUNT${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
RAM_SIZE=$(whiptail --inputbox "Allocate RAM in MiB" 8 58 $var_ram --title "RAM" 3>&1 1>&2 2>&3) RAM_SIZE=$(whiptail --inputbox "Allocate RAM in MiB" 8 58 $var_ram --title "RAM" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Allocated RAM: ${BGN}$RAM_SIZE${CL}" echo -e "${DGN}Allocated RAM: ${BGN}$RAM_SIZE${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
BRG=$(whiptail --inputbox "Set a Bridge" 8 58 vmbr0 --title "BRIDGE" 3>&1 1>&2 2>&3) BRG=$(whiptail --inputbox "Set a Bridge" 8 58 vmbr0 --title "BRIDGE" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Using Bridge: ${BGN}$BRG${CL}" echo -e "${DGN}Using Bridge: ${BGN}$BRG${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
NET=$(whiptail --inputbox "Set a Static IPv4 CIDR Address(/24)" 8 58 dhcp --title "IP ADDRESS" 3>&1 1>&2 2>&3) NET=$(whiptail --inputbox "Set a Static IPv4 CIDR Address(/24)" 8 58 dhcp --title "IP ADDRESS" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
echo -e "${DGN}Using IP Address: ${BGN}$NET${CL}" echo -e "${DGN}Using IP Address: ${BGN}$NET${CL}"
else else
clear
echo -e "⚠ User exited script \n"
exit exit
fi fi
GATE1=$(whiptail --inputbox "Set a Gateway IP (mandatory if Static IP was used)" 8 58 --title "GATEWAY IP" 3>&1 1>&2 2>&3) GATE1=$(whiptail --inputbox "Set a Gateway IP (mandatory if Static IP was used)" 8 58 --title "GATEWAY IP" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
@ -226,7 +190,6 @@ else
echo -e "${DGN}Using Gateway IP Address: ${BGN}$GATE1${CL}" echo -e "${DGN}Using Gateway IP Address: ${BGN}$GATE1${CL}"
fi fi
fi fi
MAC1=$(whiptail --inputbox "Set a MAC Address(leave blank for default)" 8 58 --title "MAC ADDRESS" 3>&1 1>&2 2>&3) MAC1=$(whiptail --inputbox "Set a MAC Address(leave blank for default)" 8 58 --title "MAC ADDRESS" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
@ -237,7 +200,6 @@ else
echo -e "${DGN}Using MAC Address: ${BGN}$MAC1${CL}" echo -e "${DGN}Using MAC Address: ${BGN}$MAC1${CL}"
fi fi
fi fi
VLAN1=$(whiptail --inputbox "Set a Vlan(leave blank for default)" 8 58 --title "VLAN" 3>&1 1>&2 2>&3) VLAN1=$(whiptail --inputbox "Set a Vlan(leave blank for default)" 8 58 --title "VLAN" 3>&1 1>&2 2>&3)
exitstatus=$? exitstatus=$?
if [ $exitstatus = 0 ]; then if [ $exitstatus = 0 ]; then
@ -248,7 +210,6 @@ else
echo -e "${DGN}Using Vlan: ${BGN}$VLAN1${CL}" echo -e "${DGN}Using Vlan: ${BGN}$VLAN1${CL}"
fi fi
fi fi
if (whiptail --title "ADVANCED SETTINGS COMPLETE" --yesno "Ready to create ${APP} LXC?" 10 58); then if (whiptail --title "ADVANCED SETTINGS COMPLETE" --yesno "Ready to create ${APP} LXC?" 10 58); then
echo -e "${RD}Creating a ${APP} LXC using the above advanced settings${CL}" echo -e "${RD}Creating a ${APP} LXC using the above advanced settings${CL}"
else else
@ -257,7 +218,6 @@ else
advanced_settings advanced_settings
fi fi
} }
function start_script() { function start_script() {
if (whiptail --title "SETTINGS" --yesno "Use Default Settings?" 10 58); then if (whiptail --title "SETTINGS" --yesno "Use Default Settings?" 10 58); then
header_info header_info
@ -271,16 +231,13 @@ fi
} }
clear clear
start_script start_script
if [ "$CT_TYPE" == "1" ]; then if [ "$CT_TYPE" == "1" ]; then
FEATURES="nesting=1,keyctl=1" FEATURES="nesting=1,keyctl=1"
else else
FEATURES="nesting=1" FEATURES="nesting=1"
fi fi
TEMP_DIR=$(mktemp -d) TEMP_DIR=$(mktemp -d)
pushd $TEMP_DIR >/dev/null pushd $TEMP_DIR >/dev/null
export CTID=$CT_ID export CTID=$CT_ID
export PCT_OSTYPE=$var_os export PCT_OSTYPE=$var_os
export PCT_OSVERSION=$var_version export PCT_OSVERSION=$var_version
@ -296,16 +253,11 @@ export PCT_OPTIONS="
$PW $PW
" "
bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/ct/create_lxc.sh)" || exit bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/ct/create_lxc.sh)" || exit
msg_info "Starting LXC Container" msg_info "Starting LXC Container"
pct start $CTID pct start $CTID
msg_ok "Started LXC Container" msg_ok "Started LXC Container"
lxc-attach -n $CTID -- bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/setup/$var_install.sh)" || exit lxc-attach -n $CTID -- bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/setup/$var_install.sh)" || exit
IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}') IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
pct set $CTID -description "# ${APP} ${var_version} LXC pct set $CTID -description "# ${APP} ${var_version} LXC
### https://tteck.github.io/Proxmox/" ### https://tteck.github.io/Proxmox/"
msg_ok "Completed Successfully!\n" msg_ok "Completed Successfully!\n"